#include <stdio.h>
#include <stdlib.h>

#include "mpi.h"


#define HELLO_TAG 100

int hello_alltoall (int count, MPI::Comm& comm)
{
  int  rank,size, dest;
  int  msg_length;
  char msg_buffer[64];
  char rcv_buffer[64];
  MPI::Status status;

  /* Determine the size of this group and the current rank */
  rank = comm.Get_rank();
  size = comm.Get_size();

  sprintf (msg_buffer, "hello from %d", rank);
  msg_length = strlen (msg_buffer)+1;
  
  /* Send the message to the other nodes */
  int round = 0;
  dest = (rank+1)%size;
  for (int c=0; c < count ; c++)
    {
      for (round = 0; round < size-1; round++)
	{
	  //int source = MPI::ANY_SOURCE;
	  if (rank == 0) 
	    {
	      //cerr << rank << " : send " << dest  << endl;
	      comm.Send (msg_buffer, msg_length, MPI::CHAR,
			 dest, HELLO_TAG);
	      //cerr << rank << " : rcv " <<  " ANY " << endl;
	      comm.Recv (rcv_buffer, 64,  MPI::CHAR, 
			 MPI::ANY_SOURCE, HELLO_TAG, status);
	    }
	  else
	    {
	      //cerr << rank << " : rcv " <<  " ANY " << endl;
	      comm.Recv (rcv_buffer, 64,  MPI::CHAR, 
			 MPI::ANY_SOURCE, HELLO_TAG, status);
	      //cerr << rank << " : send " << dest  << endl;
	      comm.Send (msg_buffer, msg_length, MPI::CHAR,
			 dest, HELLO_TAG);
	    }
	  //	  cout << rank << ": round " << round << " : got " << rcv_buffer << endl;

	  strcpy (msg_buffer, rcv_buffer);
	}
    }
  return 0;
}
		  
		  
void
thread_main(int argc, char**argv)
{
  MPI::Init (argc, argv);
  int count = 1000;
  double starttime, endtime ;

  if (argc>1) count = atoi (argv[1]);

  if (MPI::COMM_WORLD.Get_rank () == 0)
    starttime = MPI::Wtime();
 
  hello_alltoall (count, MPI::COMM_WORLD);
  
  if (MPI::COMM_WORLD.Get_rank () == 0)
    {
      endtime = MPI::Wtime();
      cout << count << " alltoall in " << endtime - starttime << endl;
    }
  

  MPI::Finalize();

}
void main(int argc, char**argv)
{
  MPI::Init (argc, argv, thread_main);
}
  


  
