#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>



#define HELLO_TAG 100

int hello_alltoall (int count, MPI_Comm comm)
{
  int rank,size, dest, round;
  int  msg_length;
  char msg_buffer[64];
  char rcv_buffer[64];
  MPI_Status status;
  int c;

  /* Determine the size of this group and the current rank */
  MPI_Comm_rank(comm, &rank);
  MPI_Comm_size(comm, &size);

  sprintf (msg_buffer, "hello from %d", rank);
  msg_length = strlen (msg_buffer)+1;
  
  /* Send the message to the other nodes */
  round = 0;
  dest = (rank+1)%size;
  for (c = 0; c < count; c++)
  for (round = 0; round < size -1 ; round++)
    {
      int source =  MPI_ANY_SOURCE;
      if (rank == 0 )
	{
	  MPI_Send (msg_buffer, msg_length, MPI_CHAR,
		    dest, HELLO_TAG, comm);
	  MPI_Recv (rcv_buffer, 64,  MPI_CHAR, 
		    source, HELLO_TAG,comm,  &status);
	}
      else
	{
	  MPI_Recv (rcv_buffer, 64,  MPI_CHAR, 
		    source, HELLO_TAG, comm, &status);
	  MPI_Send (msg_buffer, msg_length, MPI_CHAR,
		    dest, HELLO_TAG, comm);
	}
      /*printf ("%d : %s\n", rank, rcv_buffer); */
    }
  return 0;
}
		  
void		  
main(int argc, char**argv)
{
  int count = 10;
  int i, rank;
  double st,en;
  MPI_Init (&argc, &argv);

  if (argc>1)
   count = atoi (argv[1]);

  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  if (rank == 0)
    st = MPI_Wtime();
  hello_alltoall (count, MPI_COMM_WORLD);

  if (rank == 0){
    en = MPI_Wtime();
    printf ("%d alltoall in %f\n", count, en - st);
  }

  MPI_Finalize();

}


  
