// -*- c++ -*- ------------------------------------------
// Title: Comm_queue
// Author: Kristian Kvilekval
// Project:
#ifndef _Comm_queue_H
#define _Comm_queue_H

//#include <pthread.h>
//#include <list.h>
#include "envelope.h"

class Comm_queue
{
public:
  Comm_queue();
  ~Comm_queue();


  typedef list<Envelope> Queue;
  typedef Queue::iterator envelope;
public:

  bool send_rendezvous (Envelope&);
  bool recv_rendezvous (Envelope&);

  bool null_envelope (envelope e)  { return e == queue_.end(); }
  void add_envelope(Envelope&);
  void rem_envelope(envelope);
  bool find_matching_receiver (const Envelope& snd, Envelope& rcv);
  bool find_matching_sender (const Envelope& dst, Envelope& snd);
  bool rendezvous (Envelope&src, Envelope& dst);

  void lock() { pthread_mutex_lock(&gate); }
  void unlock() { pthread_mutex_unlock(&gate);}
  void signal () { ++changes; pthread_cond_broadcast(&changed); }
  void wait () { 
    while (changes==0) pthread_cond_wait(&changed, &gate);
    changes = 0;
  }
  
private:

  Queue queue_;

  pthread_mutex_t gate;
  pthread_cond_t changed;
  int changes;
};


#endif  // _Comm_queue_H
