// -*- c++ -*- ------------------------------------------
// Title: Datatype
// Author: Kristian Kvilekval
// Project:
#ifndef _Datatype_H
#define _Datatype_H

class Datatype
{
public:
  Datatype();
//   Datatype(const Datatype&rhs);
//   Datatype& operator=(const Datatype&rhs);
  
  virtual ~Datatype();
  virtual int Get_size() const { return get_size(); }

#if 0
  ///////////////////////////////////////////////////
  // Point-to-Point Communication
  static Datatype Create_struct(int count, const int array_of_blocklengths[],
				const Aint array_of_displacements[],
				const Datatype array_if_types[]);

  virtual Datatype Create_contiguous(int count) const;
  virtual Datatype Create_vector(int count, int blocklength,
				 int stride) const;
  virtual Datatype Create_indexed(int count,
				  const int array_of_blocklengths[], 
				  const int array_of_displacements[]) const;

  
  virtual Datatype Create_hindexed(int count, const int array_of_blocklengths[],
				   const Aint array_of_displacements[]) const;

  virtual Datatype Create_hvector(int count, int blocklength, Aint stride) const;

  virtual void Get_extent(Aint& lb, Aint& extent) const;
  virtual void Commit();
  virtual void Free();
  virtual void Pack(const void* inbuf, int incount, void *outbuf, 
		    int outsize, int& position, const Comm &comm) const;
  virtual void Unpack(const void* inbuf, int insize, void *outbuf, int outcount,
		      int& position, const Comm& comm) const;
  virtual int Pack_size(int incount, const Comm& comm) const;
#endif

  ///////////////////////////////////////////////////////////////
  //
  virtual void max (const void *snd, void *rcv, int count)const;
  virtual void min (const void *snd, void *rcv, int count)const;
  virtual void sum (const void *snd, void *rcv, int count)const;
protected:
  
  friend class MPI;
  friend class Comm;

  Datatype (int code, int sz) : type_code (code), size (sz) {}

  enum dt_builtin { DT_BYTE, DT_CHAR, DT_SHORT, DT_BOOLEAN, DT_INT,
		    DT_LONG, DT_FLOAT, DT_DOUBLE };

  int get_typeCode() const { return type_code; }
  int get_size () const { return size; }

  int type_code;
  int size;
};	// end of class Datatype

#if 0
class Datatype_byte : public Datatype
{
public:
  virtual void max (void *snd, void *rcv, int count);
  virtual void min (void *snd, void *rcv, int count);
  virtual void sum (void *snd, void *rcv, int count);
};


class Datatype_char : public Datatype
{
public:
  virtual void max (void *snd, void *rcv, int count);
  virtual void min (void *snd, void *rcv, int count);
  virtual void sum (void *snd, void *rcv, int count);
};

class Datatype_short : public Datatype
{
public:
  virtual void max (void *snd, void *rcv, int count);
  virtual void min (void *snd, void *rcv, int count);
  virtual void sum (void *snd, void *rcv, int count);
};

typedef Datatype_byte Datatype_boolean;

class Datatype_int : public Datatype
{
public:
  virtual void max (void *snd, void *rcv, int count);
  virtual void min (void *snd, void *rcv, int count);
  virtual void sum (void *snd, void *rcv, int count);
};

typedef Datatype_int Datatype_long;

class Datatype_float : public Datatype
{
public:
  virtual void max (void *snd, void *rcv, int count);
  virtual void min (void *snd, void *rcv, int count);
  virtual void sum (void *snd, void *rcv, int count);
};

#endif

class Datatype_double : public Datatype
{
public:
  Datatype_double() : Datatype (Datatype::DT_FLOAT, sizeof (double)) {}
  virtual void max (const void *snd, void *rcv, int count)const;
  virtual void min (const void *snd, void *rcv, int count)const;
  virtual void sum (const void *snd, void *rcv, int count)const;
};

#endif  // _Datatype_H
