// -*- c++ -*- ------------------------------------------
// Title: Envelope
// Author: Kristian Kvilekval
// Project:

#include "mpi.h"


MPI::Envelope_impl MPI::gNullEnvelope(1);


void MPI::Envelope::lock() 
{ 
//   DEBUGX(cerr <<  MPI::Get_current_task()->get_rank() 
// 	 << ": lock" << handle->mutex << endl);
  pthread_mutex_lock(handle->mutex); 
}
void MPI::Envelope::unlock() 
{
//   DEBUGX(cerr <<  MPI::Get_current_task()->get_rank() 
// 	 << ": unlock" << handle->mutex << endl);
  pthread_mutex_unlock(handle->mutex); 
}
void MPI::Envelope::signal_tasks () 
{ 
//   DEBUGX(cerr <<  MPI::Get_current_task()->get_rank() 
// 	 << ": signal" << handle->condition << endl);
  pthread_cond_broadcast(handle->condition); 
}
void MPI::Envelope::wait () 
{
//   DEBUGX(cerr <<  MPI::Get_current_task()->get_rank() 
// 	 << ": waiting" << handle->condition << ", " <<handle->mutex << endl);

  pthread_cond_wait(handle->condition, handle->mutex);
}


