// -*- c++ -*- ------------------------------------------
// Title: Group
// Author: Kristian Kvilekval
// Project:

#include "mpi.h"


void MPI::Group::initialize_group(Group&g, int n, 
				  mpi_int_main mf, 
				  int argc, 
				  char**argv)
{
  for (int i = 0; i < n; i++)
    {
      MPI::Task *tsk = new MPI::Task (mf, argc, argv);
      g.tasks.insert (g.tasks.end(), task_ptr (tsk));
      TCB.push_task (tsk);
    }
}

MPI::Group::Group()
{
}
MPI::Group::~Group()
{
  //  DEBUGX(cerr << "~Group" << endl);
}
		  

int MPI::Group::Get_size() const
{
  return tasks.size();
}

int MPI::Group::Get_rank() const
{
  MPI::Task *tsk = MPI::Get_current_task();

  for (task_set::const_iterator tp = tasks.begin(); tp != tasks.end(); ++tp)
    {
      if (*tp == task_ptr (tsk))
	return tp - tasks.begin();
    }
  return -1;
}




