// -*- c++ -*- ------------------------------------------
// Title: Group
// Author: Kristian Kvilekval
// Project:
#ifndef _Group_H
#define _Group_H


class Group
{
public:
  Group();
  //Group(const Group&rhs) : tasks (rhs.tasks) {}
  //Group& operator=(const Group&rhs) { tasks = rhs.tasks; }
  virtual ~Group();

  //////////////////////////////////////////////////////
  // Groups, Contexts, and Communicators
  virtual int Get_size() const;
  virtual int Get_rank() const;
  static void Translate_ranks (const Group& group1, int n, const int ranks1[], 
			       const Group& group2, int ranks2[]);
  static int Compare(const Group& group1, const Group& group2);
  static Group Union(const Group &group1, const Group &group2);
  static Group Intersect(const Group &group1, const Group &group2);
  static Group Difference(const Group &group1, const Group &group2);

#if 0 
  virtual Group Incl(int n, const int ranks[]) const;
  virtual Group Excl(int n, const int ranks[]) const;
  virtual Group Range_incl(int n, const int ranges[][3]) const;
  virtual Group Range_excl(int n, const int ranges[][3]) const;
  virtual void Free();
#endif

protected:
private:
  friend class MPI;
  friend class Comm;
  friend class Request;

  struct task_ptr {
    Task * task;
    task_ptr(Task*x=0) : task(x) {}
    bool operator == (const task_ptr&tp) const { return task == tp.task; }
  };
  typedef vector<task_ptr> task_set;

  static void initialize_group(Group & g, 
			       int n, 
			       mpi_int_main mf, int argc, char**argv);
  Task * index (int x) { return tasks[x].task; }
  task_set  tasks;
};	// end of class Group


#endif  // _Group_H
