// -*- c++ -*- ------------------------------------------
// Title: MPI_task
// Author: Kristian Kvilekval
// Project:
#ifndef _MPI_task_H
#define _MPI_task_H



class Task : public thread_task
{
public:
  Task(mpi_int_main f, int ac, char**av) ;
  ~Task();

  void action (int rank);

  Comm_queue& get_recv_queue () { return recv_queue; }
  int get_rank () { return rank; }
  
  static Task* get_current();
  void lock();
  void unlock();
  void wait_change();
  void signal_change();

private:
  static void init_task_key() ;
  static pthread_key_t task_key;

  mpi_int_main main_thread;
  int     argc;
  char**  argv;
  Comm_queue recv_queue;
  int rank;

  pthread_mutex_t gate;
  pthread_cond_t  change;
  int     changes;
};	// end of class task


#endif  // _MPI_task_H
