// -*- c++ -*----------------------------------------------
// Title: request
// Project:
// Author:
// Date:

#include "mpi.h"


MPI::Request::Request ()
{}
MPI::Request::~Request()
{}


void MPI::Request::Wait(Status &status)
{
  //MPI::Task * task = MPI::Get_current_task ();
//   DEBUGX (cerr << task->get_rank() << "Wait : enter" << endl);

  envelope.lock();
  for (;;)
    {
//       DEBUGX (cerr << task->get_rank() << "Wait : get_status" << endl);
      if (get_status() == MPI::Envelope::DONE)
	{
	  envelope.unlock();
	  status.set_from_envelope(envelope);
// 	  DEBUGX (cerr << task->get_rank() << "Wait : exit" << endl);
	  return;
	}
//       DEBUGX (cerr << task->get_rank() << "Wait : wait_change" << endl);
      envelope.wait();
    }
}

void MPI::Request::Wait()
{
  Status s;
  Wait (s);
}

bool MPI::Request::Test(Status &status)
{
  return false;
}

bool MPI::Request::Test()
{
  return false;
}

void MPI::Request::Free(void)
{
}

void MPI::Request::Cancel(void) const
{
}

int MPI::Request::Waitany(int count, MPI::Request reqs[], Status& status)
{
  int index = -1;
  //bool found = false;

  for (;;) 
    {
      for (index = 0; index < count; ++index)
	{
	  if (reqs[index].envelope.get_status() == MPI::Envelope::DONE)
	    {
	      status.set_from_envelope(reqs[index].envelope);
	      return index;
	    }
	}
    }
}

int MPI::Request::Waitany(int count, MPI::Request reqs[])
{
  Status status;
  return Waitany (count, reqs, status);
}

void MPI::Request::Waitall(int count, MPI::Request reqs[], Status stats[])
{
  for (int i = 0; i < count; ++i)
    reqs[i].Wait (stats[i]);
}
void MPI::Request::Waitall(int count, MPI::Request reqs[])
{
  for (int i = 0; i < count; ++i)
    reqs[i].Wait ();
}

#if 0
bool MPI::Request::Testany(int count, MPI::Request reqs[], int& index, Status& status);
bool MPI::Request::Testany(int count, MPI::Request reqs[], int& index);
bool MPI::Request::Testall(int count, MPI::Request reqs[], Status stats[]);
bool MPI::Request::Testall(int count, MPI::Request reqs[]);
int MPI::Request::Waitsome(int count, MPI::Request reqs[],
		      int array_of_indices[], Status stats[]) ;
int MPI::Request::Waitsome(int count, MPI::Request reqs[],
		      int array_of_indices[]);
int MPI::Request::Testsome(int count, MPI::Request reqs[],
		      int array_of_indices[], Status stats[]);
int MPI::Request::Testsome(int count, MPI::Request reqs[],
		      int array_of_indices[]);
#endif

//////////////////////////////////////////////////////////////////
void MPI::Request::post_send()
{
  // Find the task queue of the recv'er
  MPI::Group *g = (MPI::Group*)envelope.get_context();
  MPI::Task  *t = g->index (envelope.get_destination());
  t->get_recv_queue().send_rendezvous (envelope);
}

void MPI::Request::post_recv()
{
  // Find the task queue of the recv'er
  MPI::Group *g = (MPI::Group*)envelope.get_context();
  MPI::Task  *t = g->index (envelope.get_destination());
  t->get_recv_queue().recv_rendezvous (envelope);
}
