// -*- c++ -*- ------------------------------------------
// Title: Status
// Author: Kristian Kvilekval
// Project:

#include "mpi.h"



int MPI::Status::Get_count(const Datatype& datatype) const
{
  return envelope.get_length() / datatype.Get_size();
}

bool MPI::Status::Is_cancelled() const
{
  return envelope.get_status() == MPI::Envelope::CANCELLED;
}

int MPI::Status::Get_elements(const Datatype& datatype) const
{
  return -1;
}

int MPI::Status::Get_source() const
{
  return envelope.get_source();
}

void MPI::Status::Set_source(int source)
{
  envelope.set_source (source);
}

int MPI::Status::Get_tag() const
{
  return envelope.get_tag();
}

void MPI::Status::Set_tag(int tag)
{
  envelope.set_source (tag);
}

int MPI::Status::Get_error() const
{
  return 0;
}

void MPI::Status::Set_error(int error)
{
}
