/* ---------------------------------------------------------------------
 *  tcb.c
 *  thread control block
 *  main thread header for threaded implmentation of MM
 *
 *
 * ---------------------------------------------------------------------*/
#include "tcb.h"

#define DEBUG
//#define DEBUGX(X) X
#define DEBUGX(X)

thread_control::thread_control()
{}

void thread_control::init (int threads)
{
//   pthread_attr_t attr;
  pthread_t *thread = new pthread_t[threads];

  int count;

  cerr << "Creating " << threads << " Threads" << endl;
  // pthread_init();
  /* pthread_key_create (&rank_key, NULL); */

  if (threads <= 0) threads = 1;

  pthread_mutex_init (&start_lock, NULL);
  pthread_mutex_init (&stop_lock, NULL);
  pthread_cond_init (&start_cond, NULL);
  pthread_cond_init (&stop_cond, NULL);

  total_threads = threads;
  working = 0;
  threads_running = 0;

#ifdef __sgi
  pthread_setconcurrency (total_threads);
#endif
//  pthread_attr_init (&attr);
//  pthread_attr_setschedpolicy(&attr, SCHED_FIFO);

  for (count = 0; count < threads; count++)
    if (pthread_create (&thread[count], NULL, //&attr, 
			worker_thread, new thread_worker(this, count)))
      {
	DEBUGX(cerr << "Problem in create\n");
	exit (0);
      }
    else
      {
	DEBUGX( cerr << "thread " << count <<" created" << endl);
	//cout << "Creating " << count << endl;
      }
  //  pthread_attr_destroy (&attr);
}

/*
thread_worker thread_control::get_worker()
{
  // Get a new worker from the worker queue
  thread_worker worker;

  pthread_mutex_lock (&stop_lock);
  while (worker_queue.empty())
    pthread_cond_wait (&stop_cond, &stop_lock);
  
  worker = worker_queue.front(); worker_queue.pop();

  pthread_mutex_unlock (&stop_lock);

  return worker;
}
*/


void thread_control::push_task(thread_task *t)
{
  pthread_mutex_lock (&start_lock);

  task_queue.push (task_wrap(t));
  
  DEBUGX(cerr << "task queue " << task_queue.size() << " long" <<endl);
  
  pthread_cond_signal (&start_cond);
  pthread_mutex_unlock (&start_lock);
}

void thread_control::wait_empty()
{
  do 
    {
      pthread_mutex_lock (&stop_lock);
      while (!task_queue.empty() || working)
	pthread_cond_wait (&stop_cond, &stop_lock);

      DEBUGX(cerr << "task queue " << task_queue.size() << " long" <<endl);

      pthread_mutex_unlock (&stop_lock);
    } while (!task_queue.empty());
}

/*
void thread_control::gotowork(thread_worker w)
{
  pthread_mutex_lock (&start_lock);

  pthread_cond_signal (&start_cond);
  pthread_mutex_unlock (&start_lock);

  // Force them to grab some time 
  pthread_yield();
}

*/
thread_task::~thread_task()
{}

void thread_task::action(int /*rank*/)
{}


void * worker_thread (void *arg)
{
  ((thread_worker*)arg)->worker();
  return 0;
}

void thread_worker::worker()
{
  DEBUGX(cerr << "Worker " << pthread_self() << endl);
  task_wrap w;
  //thread_task *task;
  // Worker wait forever to do more work.
  for (;;)
    {
      /* Wait on the start condition. Grab the Mutex 
	 and get what we need to do */

      pthread_mutex_lock (&TCB->start_lock);
      while (TCB->task_queue.empty())
	pthread_cond_wait (&TCB->start_cond, &TCB->start_lock);
      w = TCB->task_queue.front();       
      TCB->task_queue.pop();
      TCB->working++;
      pthread_mutex_unlock (&TCB->start_lock);

      // Do the task.

      w.ptr->action(rank);

      delete w.ptr;

      // Put ourselves back on the worker queue.

      pthread_mutex_lock (&TCB->stop_lock);
      //TCB->worker_queue.push (*this);
      TCB->working--;
      pthread_cond_signal (&TCB->stop_cond);
      pthread_mutex_unlock (&TCB->stop_lock);
    }
}

void thread_barrier::init_barrier ()
{
  //init = 1;
  pthread_mutex_init (&count_lock, NULL);
  pthread_mutex_init (&gate_lock, NULL);
  pthread_cond_init (&gate_cond, NULL);
  count = 0;
  leaving = 0;
  DEBUGX(cerr << "init barrier :" << named << endl);
}

void thread_barrier::wait ()
{
  DEBUGX(cerr << "barrier::wait enter" << named << endl);

  // FIXME! This is bad and is a race condition 
  //if (init==0) init_barrier();

  pthread_mutex_lock (&gate_lock);

  while (leaving != 0)		// Wait for any leaving thread before entering
    pthread_cond_wait (&leaving_cond, &gate_lock);

  count++;
  if (count == total)		// When all have arrived 
    {				// Set the number that need to leave.
      leaving = total;
      pthread_cond_broadcast (&gate_cond); // Tell the others to go
    }

  while (count != total)	// Wait here until all have arrived
    pthread_cond_wait (&gate_cond, &gate_lock);

  leaving--;
  if (leaving == 0)		// Last one tell the early birds
    {
      count = 0;		// reset the counter
      pthread_cond_broadcast (&leaving_cond); // Open this up again.
    }
  pthread_mutex_unlock (&gate_lock);
  
  DEBUGX(cerr << "barrier::wait exit" << named << endl);
}

void thread_broadcast::broadcast (void *data, 
				  int bytes, 
				  int sender, 
				  int rank)
{
  DEBUGX(cerr << "broadcast::broadcast enter" << endl);

  if (sender == rank) 
    sender_data = data;

  bar.wait();
  // Find the senders data array and copy it over.

  if (sender != rank) memcpy (data, sender_data, bytes);
  
  bar.wait();
  DEBUGX(cerr << "broadcast::broadcast exit" << endl);
}
