// -*- c++ -*- ------------------------------------------
// Title: Comm_queue
// Author: Kristian Kvilekval
// Project:
#ifndef _Comm_queue_H
#define _Comm_queue_H

//#include <pthread.h>
//#include <list.h>
#include "envelope.h"

class Comm_queue
{
public:
  Comm_queue();
  ~Comm_queue();


  typedef list<Envelope> Queue;
  typedef Queue::iterator envelope;

public:

  envelope alloc_envelope(void*data, int len, int type, 
			  int tag, int src, int dst) {
    envelope q=queue_.insert(queue_.end(), Envelope(data,len,type,tag,src,dst));
    return q;
  }
  void rem_envelope(envelope x) {
    queue_.erase (x);
  }
    
  bool send_rendezvous (Envelope&);
  bool recv_rendezvous (Envelope&);

  bool null_envelope (envelope e)  { return e == queue_.end(); }
  envelope find_matching_receiver (const Envelope& snd);
  envelope find_matching_sender (const Envelope& dst);
  bool rendezvous (Envelope&src, Envelope& dst);
  void lock() { pthread_mutex_lock(&gate); }
  void unlock() { pthread_mutex_unlock(&gate);}
  void signal () { ++changes; pthread_cond_broadcast(&changed); }
  
private:
  friend class MPI;

  Queue queue_;

  pthread_mutex_t gate;
  pthread_cond_t changed;
  int changes;

  DEBUG_DECL(static int debug)
};


#endif  // _Comm_queue_H
