// -*- c++ -*- ------------------------------------------
// Title: Datatype
// Author: Kristian Kvilekval
// Project:

#include "mpi.h"

MPI::Datatype::Datatype()
{}
MPI::Datatype::~Datatype()
{
  //  cerr << "~datatype" << endl;
}
void MPI::Datatype::max (const void *snd, void *rcv, int count)const
{
  cerr << "** Sorry operation not available for type" << endl;
}
void MPI::Datatype::min (const void *snd, void *rcv, int count)const
{
  cerr << "** Sorry operation not available for type" << endl;
}
void MPI::Datatype::sum (const void *snd, void *rcv, int count)const
{
  cerr << "** Sorry operation not available for type" << endl;
}

#if 0
void Datatype_byte::max (void *snd, void *rcv, int count);
void Datatype_byte::min (void *snd, void *rcv, int count);
void Datatype_byte::sum (void *snd, void *rcv, int count);

void Datatype_char::max (void *snd, void *rcv, int count);
void Datatype_char::min (void *snd, void *rcv, int count);
void Datatype_char::sum (void *snd, void *rcv, int count);
#endif

void MPI::Datatype_double::max (const void *snd, void *rcv, int count)const
{
  double *src = (double*)snd;
  double *dst = (double*)rcv;
  while (count--)
    {
      *dst = (*src > *dst)?*src:*dst;
      ++src;
      ++dst;
    }
}

void MPI::Datatype_double::min (const void *snd, void *rcv, int count)const
{
  double *src = (double*)snd;
  double *dst = (double*)rcv;
  while (count--)
    {
      *dst = (*src < *dst)?*src:*dst;
      ++src;
      ++dst;
    }
}

void MPI::Datatype_double::sum (const void *snd, void *rcv, int count)const
{

  //  DEBUGX (cerr << "Datatype_double::sum" << endl);
  double *src = (double*)snd;
  double *dst = (double*)rcv;
  while (count--)
    {
      *dst += *src;
      ++src;
      ++dst;
    }
}


