// -*- c++ -*- ------------------------------------------
// Title: Envelope
// Author: Kristian Kvilekval
// Project:

#include "mpi.h"


ostream& operator << (ostream&o, const MPI::Envelope&e)
{
  o << "envelope(" 
    << "src=" << e.get_source() << ','
    << "dst=" << e.get_destination() << ','
    << "tag=" << e.get_tag() << ','
    << "stat=" << e.get_status() << ','
    << "len=" << e.get_length()
    << ')';
  return o;
}


void MPI::Envelope::task_lock() 
{ 
//   DEBUGX(cerr <<  MPI::Get_current_task()->get_rank() 
// 	 << ": lock" << handle->mutex << endl);
  task->lock();
}

void MPI::Envelope::task_unlock() 
{
//   DEBUGX(cerr <<  MPI::Get_current_task()->get_rank() 
// 	 << ": unlock" << handle->mutex << endl);
  task->unlock();
}

void MPI::Envelope::task_signal_complete () 
{ 
//   DEBUGX(cerr <<  MPI::Get_current_task()->get_rank() 
// 	 << ": signal" << handle->condition << endl);
  task->inc_completed();
  task->signal_completed();
//   DEBUGX (cerr <<task->get_rank()<<" : signal " <<task->completed()<<endl);
}



