// -*- c++ -*- --------------------------------------------------
// intracomm.h
//
#ifndef _MPI_INTRACOMM_H
#define _MPI_INTRACOMM_H


class Intracomm : public Comm
{
public:
  Intracomm () {} 
//   Intracomm (const Intracomm&);
  ~Intracomm ();

  ///////////////////////////////////////////////////
  // 
#if 0
  Intracomm Dup() const;
  virtual Intracomm& Clone() const;
  virtual Intracomm Create(const Group& group) const;
  virtual Intracomm Split(int color, int key) const;
  virtual Intercomm Create_intercomm(int local_leader, const Comm& peer_comm,
				     int remote_leader, int tag) const;
  virtual Cartcomm Create_cart(int ndims, const int dims[],
			       const bool periods[], bool reorder) const;
  virtual Graphcomm Create_graph(int nnodes, const int index[],
				 const int edges[], bool reorder) const;
#endif

  //////////////////////////////////////////////////
  // Collective Communication

  virtual void Barrier() ;
  virtual void Bcast(void *buffer, int count, 
		     const Datatype& datatype, int root) ;


  virtual void Reduce(const void *sendbuf, void *recvbuf, int count, 
		      const Datatype & datatype, const Op & op, 
		      int root) ;
  
#if 0  
  virtual void Gather(const void *sendbuf, int sendcount, 
		      const Datatype & sendtype, 
		      void *recvbuf, int recvcount, 
		      const Datatype & recvtype, int root) const;

  virtual void Gatherv(const void *sendbuf, int sendcount, 
		       const Datatype & sendtype, void *recvbuf, 
		       const int recvcounts[], const int displs[], 
		       const Datatype & recvtype, int root) const;
  
  virtual void  Scatter(const void *sendbuf, int sendcount, 
			const Datatype & sendtype, 
			void *recvbuf, int recvcount, 
			const Datatype & recvtype, int root) const;
  
  virtual void Scatterv(const void *sendbuf, const int sendcounts[], 
			const int displs[], const Datatype & sendtype,
			void *recvbuf, int recvcount, 
			const Datatype & recvtype, int root) const;
  
  virtual void Allgather(const void *sendbuf, int sendcount, 
			 const Datatype & sendtype, void *recvbuf, 
			 int recvcount, const Datatype & recvtype) const;
  
  virtual void Allgatherv(const void *sendbuf, int sendcount, 
			  const Datatype & sendtype, void *recvbuf, 
			  const int recvcounts[], const int displs[],
			  const Datatype & recvtype) const;
  
  virtual void Alltoall(const void *sendbuf, int sendcount, 
			const Datatype & sendtype, void *recvbuf, 
			int recvcount, const Datatype & recvtype) const;
  
  virtual void Alltoallv(const void *sendbuf, const int sendcounts[], 
			 const int sdispls[], const Datatype & sendtype, 
			 void *recvbuf, const int recvcounts[], 
			 const int rdispls[], const Datatype & recvtype) const;
  
  
  virtual void Allreduce(const void *sendbuf, void *recvbuf, int count,
			 const Datatype & datatype, const Op & op) const;
  
  virtual void Reduce_scatter(const void *sendbuf, void *recvbuf, 
			      int recvcounts[], 
			      const Datatype & datatype, 
			      const Op & op) const;
  
  virtual void Scan(const void *sendbuf, void *recvbuf, int count, 
		    const Datatype & datatype, const Op & op) const;
#endif
  
private:
  friend class MPI;

  void set_barrier_size (int x) { barrier.set_size (x); }

  thread_barrier barrier;
  void *bcast_data;
};


#endif // _MPI_INTRACOMM_H
