// -*- c++ -*----------------------------------------------
// Title: request.h
// Project:
// Author:
// Date:
#ifndef _Request_H
#define _Request_H



#include "envelope.h"
#include "status.h"

class Request 
{
public:
  Request ();
  //Request(const Request&rhs);

  //Request& operator=(const Request&rhs);
  virtual ~Request();

  virtual void Wait(Status &status);
  virtual void Wait();
  virtual bool Test(Status &status);
  virtual bool Test();
  virtual void Free(void);
  virtual void Cancel(void) const;

  static int Waitany(int count, Request array[], Status& status);
  static int Waitany(int count, Request array[]);
  static bool Testany(int count, Request array[], int& index, Status& status);
  static bool Testany(int count, Request array[], int& index);
  static void Waitall(int count, Request req_array[], Status stat_array[]);
  static void Waitall(int count, Request req_array[]);
  static bool Testall(int count, Request req_array[], Status stat_array[]);
  static bool Testall(int count, Request req_array[]);
  static int Waitsome(int count, Request req_array[],
		      int array_of_indices[], Status stat_array[]) ;
  static int Waitsome(int count, Request req_array[],
		      int array_of_indices[]);
  static int Testsome(int count, Request req_array[],
		      int array_of_indices[], Status stat_array[]);
  static int Testsome(int count, Request req_array[],
		      int array_of_indices[]);

private:
  friend class MPI;
  friend class Comm;

  Request (Comm_queue::envelope ev) : envelope(ev) {}

//   void post_send();
//   void post_recv();

  Envelope& get_envelope() { return *envelope; }

  int get_status () { return (*envelope).get_status(); }
  void set_status(int x) { (*envelope).set_status (x); }
  Task *get_task () { return (*envelope).get_task(); }
  void reclaim_envelope() { get_task()->kill_invitation (envelope); }
  void set_completed (int status) { 
    set_status(status); 
    (*envelope).task_signal_complete();
  }

  Comm_queue::envelope envelope;

  DEBUG_DECL(static int debug)
};


#endif   // _Request_H
