# Run the test on certain program
# One arghument specifies the number of processors
# we shoud run the tests for
set -x

PROCS=${1:-4}; shift
RESULTS="${2:-results}-np${PROCS}"

NATIVE=../native-mpi
DEMO=../demos

PROGS="alltoall pi cpi matrix plu plu++"

if [ -f ${RESULTS} ] ; then 
   mv ${RESULTS} ${RESULTS}.old
fi


for P in ${PROGS}
do
 echo "===============================================" >> ${RESULTS}
 uptime >> ${RESULTS}
 echo "===============================================" >> ${RESULTS}
 if [ -f ${P}.args ] ; then
   ARGS=`cat ${P}.args`
 else
   ARGS=
 fi

 if [ -f ${DEMO}/${P} ] ; then
   echo "--MPI++ " ${P} ${ARGS} "--------------------" >> ${RESULTS}
   if [ -f ${P}.input ]  ; then
     ${DEMO}/${P} -np ${PROCS} ${ARGS}< ${P}.input >> ${RESULTS}
    else
     ${DEMO}/${P} -np ${PROCS} ${ARGS}             >> ${RESULTS}
   fi
 fi
 if [ -f ${NATIVE}/${P} ] ; then
   echo "--MPI " ${P} ${ARGS} "--------------------" >> ${RESULTS}
   if [ -f ${P}.input ]  ; then
     mpirun -np ${PROCS} ${NATIVE}/${P} ${ARGS} < ${P}.input >> ${RESULTS}
   else
     mpirun -np ${PROCS} ${NATIVE}/${P} ${ARGS}              >> ${RESULTS}
   fi
 fi
done
